diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/post.php ./wordpress-3.4/wp-admin/includes/post.php
*** ./wordpress-3.3.2/wp-admin/includes/post.php	2011-11-24 10:06:17.000000000 -0600
--- ./wordpress-3.4/wp-admin/includes/post.php	2012-05-03 11:41:59.000000000 -0500
***************
*** 171,177 ****
  	$post_data = _wp_translate_postdata( true, $post_data );
  	if ( is_wp_error($post_data) )
  		wp_die( $post_data->get_error_message() );
! 	if ( 'autosave' != $post_data['action']  && 'auto-draft' == $post_data['post_status'] )
  		$post_data['post_status'] = 'draft';
  
  	if ( isset($post_data['visibility']) ) {
--- 171,177 ----
  	$post_data = _wp_translate_postdata( true, $post_data );
  	if ( is_wp_error($post_data) )
  		wp_die( $post_data->get_error_message() );
! 	if ( 'autosave' != $post_data['action'] && 'auto-draft' == $post_data['post_status'] )
  		$post_data['post_status'] = 'draft';
  
  	if ( isset($post_data['visibility']) ) {
***************
*** 302,311 ****
  			if ( empty($terms) )
  				continue;
  			if ( is_taxonomy_hierarchical( $tax_name ) ) {
! 				$tax_input[$tax_name] = array_map( 'absint', $terms );
  			} else {
! 				$tax_input[$tax_name] = preg_replace( '/\s*,\s*/', ',', rtrim( trim($terms), ' ,' ) );
! 				$tax_input[$tax_name] = explode(',', $tax_input[$tax_name]);
  			}
  		}
  	}
--- 302,313 ----
  			if ( empty($terms) )
  				continue;
  			if ( is_taxonomy_hierarchical( $tax_name ) ) {
! 				$tax_input[ $tax_name ] = array_map( 'absint', $terms );
  			} else {
! 				$comma = _x( ',', 'tag delimiter' );
! 				if ( ',' !== $comma )
! 					$terms = str_replace( $comma, ',', $terms );
! 				$tax_input[ $tax_name ] = explode( ',', trim( $terms, " \n\t\r\0\x0B," ) );
  			}
  		}
  	}
***************
*** 352,358 ****
  		$tax_names = get_object_taxonomies( $post );
  		foreach ( $tax_names as $tax_name ) {
  			$taxonomy_obj = get_taxonomy($tax_name);
! 			if (  isset( $tax_input[$tax_name]) && current_user_can( $taxonomy_obj->cap->assign_terms ) )
  				$new_terms = $tax_input[$tax_name];
  			else
  				$new_terms = array();
--- 354,360 ----
  		$tax_names = get_object_taxonomies( $post );
  		foreach ( $tax_names as $tax_name ) {
  			$taxonomy_obj = get_taxonomy($tax_name);
! 			if ( isset( $tax_input[$tax_name]) && current_user_can( $taxonomy_obj->cap->assign_terms ) )
  				$new_terms = $tax_input[$tax_name];
  			else
  				$new_terms = array();
***************
*** 415,424 ****
  		$post_excerpt = esc_html( stripslashes( $_REQUEST['excerpt'] ));
  
  	if ( $create_in_db ) {
- 		// Cleanup old auto-drafts more than 7 days old
- 		$old_posts = $wpdb->get_col( "SELECT ID FROM $wpdb->posts WHERE post_status = 'auto-draft' AND DATE_SUB( NOW(), INTERVAL 7 DAY ) > post_date" );
- 		foreach ( (array) $old_posts as $delete )
- 			wp_delete_post( $delete, true ); // Force delete
  		$post_id = wp_insert_post( array( 'post_title' => __( 'Auto Draft' ), 'post_type' => $post_type, 'post_status' => 'auto-draft' ) );
  		$post = get_post( $post_id );
  		if ( current_theme_supports( 'post-formats' ) && post_type_supports( $post->post_type, 'post-formats' ) && get_option( 'default_post_format' ) )
--- 417,422 ----
***************
*** 747,796 ****
   * @return unknown
   */
  function _fix_attachment_links( $post_ID ) {
- 	global $_fix_attachment_link_id;
- 
  	$post = & get_post( $post_ID, ARRAY_A );
  
! 	$search = "#<a[^>]+rel=('|\")[^'\"]*attachment[^>]*>#ie";
! 
! 	// See if we have any rel="attachment" links
! 	if ( 0 == preg_match_all( $search, $post['post_content'], $anchor_matches, PREG_PATTERN_ORDER ) )
  		return;
  
! 	$i = 0;
! 	$search = "#[\s]+rel=(\"|')(.*?)wp-att-(\d+)\\1#i";
! 	foreach ( $anchor_matches[0] as $anchor ) {
! 		if ( 0 == preg_match( $search, $anchor, $id_matches ) )
! 			continue;
  
! 		$id = (int) $id_matches[3];
  
! 		// While we have the attachment ID, let's adopt any orphans.
! 		$attachment = & get_post( $id, ARRAY_A );
! 		if ( ! empty( $attachment) && ! is_object( get_post( $attachment['post_parent'] ) ) ) {
! 			$attachment['post_parent'] = $post_ID;
! 			// Escape data pulled from DB.
! 			$attachment = add_magic_quotes( $attachment );
! 			wp_update_post( $attachment );
! 		}
  
! 		$post_search[$i] = $anchor;
! 		 $_fix_attachment_link_id = $id;
! 		$post_replace[$i] = preg_replace_callback( "#href=(\"|')[^'\"]*\\1#", '_fix_attachment_links_replace_cb', $anchor );
! 		++$i;
! 	}
  
! 	$post['post_content'] = str_replace( $post_search, $post_replace, $post['post_content'] );
  
! 	// Escape data pulled from DB.
! 	$post = add_magic_quotes( $post);
  
! 	return wp_update_post( $post);
! }
  
! function _fix_attachment_links_replace_cb($match) {
!         global $_fix_attachment_link_id;
!         return stripslashes( 'href='.$match[1] ).get_attachment_link( $_fix_attachment_link_id ).stripslashes( $match[1] );
  }
  
  /**
--- 745,791 ----
   * @return unknown
   */
  function _fix_attachment_links( $post_ID ) {
  	$post = & get_post( $post_ID, ARRAY_A );
+ 	$content = $post['post_content'];
  
! 	// quick sanity check, don't run if no pretty permalinks or post is not published
! 	if ( !get_option('permalink_structure') || $post['post_status'] != 'publish' )
  		return;
  
! 	// Short if there aren't any links or no '?attachment_id=' strings (strpos cannot be zero)
! 	if ( !strpos($content, '?attachment_id=') || !preg_match_all( '/<a ([^>]+)>[\s\S]+?<\/a>/', $content, $link_matches ) )
! 		return;
  
! 	$site_url = get_bloginfo('url');
! 	$site_url = substr( $site_url, (int) strpos($site_url, '://') ); // remove the http(s)
! 	$replace = '';
! 
! 	foreach ( $link_matches[1] as $key => $value ) {
! 		if ( !strpos($value, '?attachment_id=') || !strpos($value, 'wp-att-')
! 			|| !preg_match( '/href=(["\'])[^"\']*\?attachment_id=(\d+)[^"\']*\\1/', $value, $url_match )
! 			|| !preg_match( '/rel=["\'][^"\']*wp-att-(\d+)/', $value, $rel_match ) )
! 				continue;
  
! 		$quote = $url_match[1]; // the quote (single or double)
! 		$url_id = (int) $url_match[2];
! 		$rel_id = (int) $rel_match[1];
  
! 		if ( !$url_id || !$rel_id || $url_id != $rel_id || strpos($url_match[0], $site_url) === false )
! 			continue;
  
! 		$link = $link_matches[0][$key];
! 		$replace = str_replace( $url_match[0], 'href=' . $quote . get_attachment_link( $url_id ) . $quote, $link );
  
! 		$content = str_replace( $link, $replace, $content );
! 	}
  
! 	if ( $replace ) {
! 		$post['post_content'] = $content;
! 		// Escape data pulled from DB.
! 		$post = add_magic_quotes($post);
  
! 		return wp_update_post($post);
! 	}
  }
  
  /**
***************
*** 973,979 ****
  }
  
  function _edit_attachments_query_helper($where) {
! 	return $where .= ' AND post_parent < 1';
  }
  
  /**
--- 968,975 ----
  }
  
  function _edit_attachments_query_helper($where) {
! 	global $wpdb;
! 	return $where .= " AND {$wpdb->posts}.post_parent < 1";
  }
  
  /**
***************
*** 1140,1151 ****
   * @since 2.9.0
   *
   * @param int $thumbnail_id ID of the attachment used for thumbnail
   * @return string html
   */
! function _wp_post_thumbnail_html( $thumbnail_id = NULL ) {
  	global $content_width, $_wp_additional_image_sizes, $post_ID;
! 	$set_thumbnail_link = '<p class="hide-if-no-js"><a title="' . esc_attr__( 'Set featured image' ) . '" href="' . esc_url( get_upload_iframe_src('image') ) . '" id="set-post-thumbnail" class="thickbox">%s</a></p>';
! 	$content = sprintf($set_thumbnail_link, esc_html__( 'Set featured image' ));
  
  	if ( $thumbnail_id && get_post( $thumbnail_id ) ) {
  		$old_content_width = $content_width;
--- 1136,1153 ----
   * @since 2.9.0
   *
   * @param int $thumbnail_id ID of the attachment used for thumbnail
+  * @param int $post_id ID of the post associated with the thumbnail, defaults to global $post_ID
   * @return string html
   */
! function _wp_post_thumbnail_html( $thumbnail_id = null, $post_id = null ) {
  	global $content_width, $_wp_additional_image_sizes, $post_ID;
! 
! 	if ( empty( $post_id ) )
! 		$post_id = $post_ID;
! 
! 	$upload_iframe_src = esc_url( get_upload_iframe_src('image', $post_id) );
! 	$set_thumbnail_link = '<p class="hide-if-no-js"><a title="' . esc_attr__( 'Set featured image' ) . '" href="%s" id="set-post-thumbnail" class="thickbox">%s</a></p>';
! 	$content = sprintf( $set_thumbnail_link, $upload_iframe_src, esc_html__( 'Set featured image' ) );
  
  	if ( $thumbnail_id && get_post( $thumbnail_id ) ) {
  		$old_content_width = $content_width;
***************
*** 1155,1162 ****
  		else
  			$thumbnail_html = wp_get_attachment_image( $thumbnail_id, 'post-thumbnail' );
  		if ( !empty( $thumbnail_html ) ) {
! 			$ajax_nonce = wp_create_nonce( "set_post_thumbnail-$post_ID" );
! 			$content = sprintf($set_thumbnail_link, $thumbnail_html);
  			$content .= '<p class="hide-if-no-js"><a href="#" id="remove-post-thumbnail" onclick="WPRemoveThumbnail(\'' . $ajax_nonce . '\');return false;">' . esc_html__( 'Remove featured image' ) . '</a></p>';
  		}
  		$content_width = $old_content_width;
--- 1157,1164 ----
  		else
  			$thumbnail_html = wp_get_attachment_image( $thumbnail_id, 'post-thumbnail' );
  		if ( !empty( $thumbnail_html ) ) {
! 			$ajax_nonce = wp_create_nonce( "set_post_thumbnail-$post_id" );
! 			$content = sprintf( $set_thumbnail_link, $upload_iframe_src, $thumbnail_html );
  			$content .= '<p class="hide-if-no-js"><a href="#" id="remove-post-thumbnail" onclick="WPRemoveThumbnail(\'' . $ajax_nonce . '\');return false;">' . esc_html__( 'Remove featured image' ) . '</a></p>';
  		}
  		$content_width = $old_content_width;
***************
*** 1259,1265 ****
  	if ( is_wp_error( $translated ) )
  		return $translated;
  
! 	// Only store one autosave.  If there is already an autosave, overwrite it.
  	if ( $old_autosave = wp_get_post_autosave( $post_id ) ) {
  		$new_autosave = _wp_post_revision_fields( $_POST, true );
  		$new_autosave['ID'] = $old_autosave->ID;
--- 1261,1267 ----
  	if ( is_wp_error( $translated ) )
  		return $translated;
  
! 	// Only store one autosave. If there is already an autosave, overwrite it.
  	if ( $old_autosave = wp_get_post_autosave( $post_id ) ) {
  		$new_autosave = _wp_post_revision_fields( $_POST, true );
  		$new_autosave['ID'] = $old_autosave->ID;
***************
*** 1320,1326 ****
  
  	if ( 'draft' == $post->post_status ) {
  		$id = edit_post();
! 	} else { // Non drafts are not overwritten.  The autosave is stored in a special post revision.
  		$id = wp_create_post_autosave( $post->ID );
  		if ( ! is_wp_error($id) )
  			$id = $post->ID;
--- 1322,1328 ----
  
  	if ( 'draft' == $post->post_status ) {
  		$id = edit_post();
! 	} else { // Non drafts are not overwritten. The autosave is stored in a special post revision.
  		$id = wp_create_post_autosave( $post->ID );
  		if ( ! is_wp_error($id) )
  			$id = $post->ID;
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/screen.php ./wordpress-3.4/wp-admin/includes/screen.php
*** ./wordpress-3.3.2/wp-admin/includes/screen.php	2011-12-06 18:13:52.000000000 -0600
--- ./wordpress-3.4/wp-admin/includes/screen.php	2012-05-03 11:41:59.000000000 -0500
***************
*** 114,120 ****
   *
   * @param string $option An option name.
   * @param mixed $args Option-dependent arguments.
-  * @return void
   */
  function add_screen_option( $option, $args = array() ) {
  	$current_screen = get_current_screen();
--- 114,119 ----
***************
*** 176,182 ****
   *
   * @since 3.1.0
   *
!  * @return object Current screen object
   */
  function get_current_screen() {
  	global $current_screen;
--- 175,181 ----
   *
   * @since 3.1.0
   *
!  * @return WP_Screen Current screen object
   */
  function get_current_screen() {
  	global $current_screen;
***************
*** 196,202 ****
   * @param mixed $hook_name Optional. The hook name (also known as the hook suffix) used to determine the screen,
   *	or an existing screen object.
   */
! function set_current_screen( $hook_name =  '' ) {
  	WP_Screen::get( $hook_name )->set_current_screen();
  }
  
--- 195,201 ----
   * @param mixed $hook_name Optional. The hook name (also known as the hook suffix) used to determine the screen,
   *	or an existing screen object.
   */
! function set_current_screen( $hook_name = '' ) {
  	WP_Screen::get( $hook_name )->set_current_screen();
  }
  
***************
*** 208,214 ****
   */
  final class WP_Screen {
  	/**
! 	 * Any action associated with the screen. 'add' for *-add.php and *-new.php screens.  Empty otherwise.
  	 *
  	 * @since 3.3.0
  	 * @var string
--- 207,213 ----
   */
  final class WP_Screen {
  	/**
! 	 * Any action associated with the screen. 'add' for *-add.php and *-new.php screens. Empty otherwise.
  	 *
  	 * @since 3.3.0
  	 * @var string
***************
*** 217,223 ****
  	public $action;
  
  	/**
! 	 * The base type of the screen.  This is typically the same as $id but with any post types and taxonomies stripped.
  	 * For example, for an $id of 'edit-post' the base is 'edit'.
  	 *
  	 * @since 3.3.0
--- 216,222 ----
  	public $action;
  
  	/**
! 	 * The base type of the screen. This is typically the same as $id but with any post types and taxonomies stripped.
  	 * For example, for an $id of 'edit-post' the base is 'edit'.
  	 *
  	 * @since 3.3.0
***************
*** 227,232 ****
--- 226,240 ----
  	public $base;
  
  	/**
+ 	 * The number of columns to display. Access with get_columns().
+ 	 *
+ 	 * @since 3.4.0
+ 	 * @var int
+ 	 * @access private
+ 	 */
+ 	private $columns = 0;
+ 
+ 	/**
  	 * The unique ID of the screen.
  	 *
  	 * @since 3.3.0
***************
*** 539,545 ****
  	 *
  	 * @since 3.3.0
  	 *
! 	 * @param string $parent_file The parent file of the screen.  Typically the $parent_file global.
  	 */
  	function set_parentage( $parent_file ) {
  		$this->parent_file = $parent_file;
--- 547,553 ----
  	 *
  	 * @since 3.3.0
  	 *
! 	 * @param string $parent_file The parent file of the screen. Typically the $parent_file global.
  	 */
  	function set_parentage( $parent_file ) {
  		$this->parent_file = $parent_file;
***************
*** 565,571 ****
  	 *
  	 * @since 3.3.0
  	 *
! 	 * @param string
  	 */
  	public function get_option( $option, $key = false ) {
  		if ( ! isset( $this->_options[ $option ] ) )
--- 573,580 ----
  	 *
  	 * @since 3.3.0
  	 *
! 	 * @param string $option Option ID.
! 	 * @param mixed $key Optional. Specific array key for when the option is an array.
  	 */
  	public function get_option( $option, $key = false ) {
  		if ( ! isset( $this->_options[ $option ] ) )
***************
*** 579,584 ****
--- 588,618 ----
  	}
  
  	/**
+ 	 * Gets the help tabs registered for the screen.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @return array Help tabs with arguments.
+ 	 */
+ 	public function get_help_tabs() {
+ 		return $this->_help_tabs;
+ 	}
+ 
+ 	/**
+ 	 * Gets the arguments for a help tab.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param string $id Help Tab ID.
+ 	 * @return array Help tab arguments.
+ 	 */
+ 	public function get_help_tab( $id ) {
+ 		if ( ! isset( $this->_help_tabs[ $id ] ) )
+ 			return null;
+ 		return $this->_help_tabs[ $id ];
+ 	}
+ 
+ 	/**
  	 * Add a help tab to the contextual help for the screen.
  	 * Call this on the load-$pagenow hook for the relevant screen.
  	 *
***************
*** 606,612 ****
  		if ( ! $args['id'] || ! $args['title'] )
  			return;
  
! 		$this->_help_tabs[] = $args;
  	}
  
  	/**
--- 640,647 ----
  		if ( ! $args['id'] || ! $args['title'] )
  			return;
  
! 		// Allows for overriding an existing tab with that ID.
! 		$this->_help_tabs[ $args['id'] ] = $args;
  	}
  
  	/**
***************
*** 630,635 ****
--- 665,681 ----
  	}
  
  	/**
+ 	 * Gets the content from a contextual help sidebar.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @return string Contents of the help sidebar.
+ 	 */
+ 	public function get_help_sidebar() {
+ 		return $this->_help_sidebar;
+ 	}
+ 
+ 	/**
  	 * Add a sidebar to the contextual help for the screen.
  	 * Call this in template files after admin.php is loaded and before admin-header.php is loaded to add a sidebar to the contextual help.
  	 *
***************
*** 642,647 ****
--- 688,710 ----
  	}
  
  	/**
+ 	 * Gets the number of layout columns the user has selected.
+ 	 *
+ 	 * The layout_columns option controls the max number and default number of
+ 	 * columns. This method returns the number of columns within that range selected
+ 	 * by the user via Screen Options. If no selection has been made, the default
+ 	 * provisioned in layout_columns is returned. If the screen does not support
+ 	 * selecting the number of layout columns, 0 is returned.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @return int Number of columns to display.
+ 	 */
+ 	public function get_columns() {
+ 		return $this->columns;
+ 	}
+ 
+ 	/**
  	 * Render the screen's help section.
  	 *
  	 * This will trigger the deprecated filters for backwards compatibility.
***************
*** 657,663 ****
  		$old_help = apply_filters( 'contextual_help', $old_help, $this->id, $this );
  
  		// Default help only if there is no old-style block of text and no new-style help tabs.
! 		if ( empty( $old_help ) && empty( $this->_help_tabs ) ) {
  			$default_help = apply_filters( 'default_contextual_help', '' );
  			if ( $default_help )
  				$old_help = '<p>' . $default_help . '</p>';
--- 720,726 ----
  		$old_help = apply_filters( 'contextual_help', $old_help, $this->id, $this );
  
  		// Default help only if there is no old-style block of text and no new-style help tabs.
! 		if ( empty( $old_help ) && ! $this->get_help_tabs() ) {
  			$default_help = apply_filters( 'default_contextual_help', '' );
  			if ( $default_help )
  				$old_help = '<p>' . $default_help . '</p>';
***************
*** 671,680 ****
  			) );
  		}
  
! 		$has_sidebar = ! empty( $this->_help_sidebar );
  
  		$help_class = 'hidden';
! 		if ( ! $has_sidebar )
  			$help_class .= ' no-sidebar';
  
  		// Time to render!
--- 734,743 ----
  			) );
  		}
  
! 		$help_sidebar = $this->get_help_sidebar();
  
  		$help_class = 'hidden';
! 		if ( ! $help_sidebar )
  			$help_class .= ' no-sidebar';
  
  		// Time to render!
***************
*** 686,720 ****
  				<div id="contextual-help-columns">
  					<div class="contextual-help-tabs">
  						<ul>
! 						<?php foreach ( $this->_help_tabs as $i => $tab ):
  							$link_id  = "tab-link-{$tab['id']}";
  							$panel_id = "tab-panel-{$tab['id']}";
- 							$classes  = ( $i == 0 ) ? 'active' : '';
  							?>
  
! 							<li id="<?php echo esc_attr( $link_id ); ?>" class="<?php echo esc_attr( $classes ); ?>">
  								<a href="<?php echo esc_url( "#$panel_id" ); ?>">
  									<?php echo esc_html( $tab['title'] ); ?>
  								</a>
  							</li>
! 						<?php endforeach; ?>
  						</ul>
  					</div>
  
! 					<?php if ( $has_sidebar ) : ?>
  					<div class="contextual-help-sidebar">
! 						<?php echo self::$this->_help_sidebar; ?>
  					</div>
  					<?php endif; ?>
  
  					<div class="contextual-help-tabs-wrap">
! 						<?php foreach ( $this->_help_tabs as $i => $tab ):
  							$panel_id = "tab-panel-{$tab['id']}";
- 							$classes  = ( $i == 0 ) ? 'active' : '';
- 							$classes .= ' help-tab-content';
  							?>
  
! 							<div id="<?php echo esc_attr( $panel_id ); ?>" class="<?php echo esc_attr( $classes ); ?>">
  								<?php
  								// Print tab content.
  								echo $tab['content'];
--- 749,787 ----
  				<div id="contextual-help-columns">
  					<div class="contextual-help-tabs">
  						<ul>
! 						<?php
! 						$class = ' class="active"';
! 						foreach ( $this->get_help_tabs() as $tab ) :
  							$link_id  = "tab-link-{$tab['id']}";
  							$panel_id = "tab-panel-{$tab['id']}";
  							?>
  
! 							<li id="<?php echo esc_attr( $link_id ); ?>"<?php echo $class; ?>>
  								<a href="<?php echo esc_url( "#$panel_id" ); ?>">
  									<?php echo esc_html( $tab['title'] ); ?>
  								</a>
  							</li>
! 						<?php
! 							$class = '';
! 						endforeach;
! 						?>
  						</ul>
  					</div>
  
! 					<?php if ( $help_sidebar ) : ?>
  					<div class="contextual-help-sidebar">
! 						<?php echo $help_sidebar; ?>
  					</div>
  					<?php endif; ?>
  
  					<div class="contextual-help-tabs-wrap">
! 						<?php
! 						$classes = 'help-tab-content active';
! 						foreach ( $this->get_help_tabs() as $tab ):
  							$panel_id = "tab-panel-{$tab['id']}";
  							?>
  
! 							<div id="<?php echo esc_attr( $panel_id ); ?>" class="<?php echo $classes; ?>">
  								<?php
  								// Print tab content.
  								echo $tab['content'];
***************
*** 724,745 ****
  									call_user_func_array( $tab['callback'], array( $this, $tab ) );
  								?>
  							</div>
! 						<?php endforeach; ?>
  					</div>
  				</div>
  			</div>
  		<?php
  		// Add screen options
  		if ( $this->show_screen_options() )
  			$this->render_screen_options();
  		?>
  		</div>
  		<?php
! 		if ( ! $this->_help_tabs && ! $this->show_screen_options() )
  			return;
  		?>
  		<div id="screen-meta-links">
! 		<?php if ( $this->_help_tabs ) : ?>
  			<div id="contextual-help-link-wrap" class="hide-if-no-js screen-meta-toggle">
  			<a href="#contextual-help-wrap" id="contextual-help-link" class="show-settings"><?php _e( 'Help' ); ?></a>
  			</div>
--- 791,831 ----
  									call_user_func_array( $tab['callback'], array( $this, $tab ) );
  								?>
  							</div>
! 						<?php
! 							$classes = 'help-tab-content';
! 						endforeach;
! 						?>
  					</div>
  				</div>
  			</div>
  		<?php
+ 		// Setup layout columns
+ 
+ 		// Back compat for plugins using the filter instead of add_screen_option()
+ 		$columns = apply_filters( 'screen_layout_columns', array(), $this->id, $this );
+ 
+ 		if ( ! empty( $columns ) && isset( $columns[ $this->id ] ) )
+ 			$this->add_option( 'layout_columns', array('max' => $columns[ $this->id ] ) );
+ 
+ 		if ( $this->get_option( 'layout_columns' ) ) {
+ 			$this->columns = (int) get_user_option("screen_layout_$this->id");
+ 
+ 			if ( ! $this->columns && $this->get_option( 'layout_columns', 'default' ) )
+ 				$this->columns = $this->get_option( 'layout_columns', 'default' );
+ 		}
+ 		$GLOBALS[ 'screen_layout_columns' ] = $this->columns; // Set the global for back-compat.
+ 
  		// Add screen options
  		if ( $this->show_screen_options() )
  			$this->render_screen_options();
  		?>
  		</div>
  		<?php
! 		if ( ! $this->get_help_tabs() && ! $this->show_screen_options() )
  			return;
  		?>
  		<div id="screen-meta-links">
! 		<?php if ( $this->get_help_tabs() ) : ?>
  			<div id="contextual-help-link-wrap" class="hide-if-no-js screen-meta-toggle">
  			<a href="#contextual-help-wrap" id="contextual-help-link" class="show-settings"><?php _e( 'Help' ); ?></a>
  			</div>
***************
*** 792,800 ****
  		?>
  		<div id="screen-options-wrap" class="hidden">
  		<form id="adv-settings" action="" method="post">
  		<?php
  		if ( isset( $wp_meta_boxes[ $this->id ] ) ) : ?>
- 			<h5><?php _ex('Show on screen', 'Metaboxes') ?></h5>
  			<div class="metabox-prefs">
  				<?php
  					meta_box_prefs( $this );
--- 878,889 ----
  		?>
  		<div id="screen-options-wrap" class="hidden">
  		<form id="adv-settings" action="" method="post">
+ 		<?php if ( isset( $wp_meta_boxes[ $this->id ] ) || $this->get_option( 'per_page' ) || ( $columns && empty( $columns['_title'] ) ) ) : ?>
+ 			<h5><?php _e( 'Show on screen' ); ?></h5>
  		<?php
+ 		endif;
+ 
  		if ( isset( $wp_meta_boxes[ $this->id ] ) ) : ?>
  			<div class="metabox-prefs">
  				<?php
  					meta_box_prefs( $this );
***************
*** 809,823 ****
  								$welcome_checked = false;
  						}
  						echo '<label for="wp_welcome_panel-hide">';
! 						echo '<input type="checkbox" id="wp_welcome_panel-hide"' . checked( (bool) $welcome_checked, true, false )  . ' />';
! 						echo __( 'Welcome' ) . "</label>\n";
  					}
  				?>
  				<br class="clear" />
  			</div>
  			<?php endif;
! 			if ( ! empty( $columns ) ) : ?>
! 			<h5><?php echo ( isset( $columns['_title'] ) ?  $columns['_title'] :  _x('Show on screen', 'Columns') ) ?></h5>
  			<div class="metabox-prefs">
  				<?php
  				$special = array('_title', 'cb', 'comment', 'media', 'name', 'title', 'username', 'blogname');
--- 898,914 ----
  								$welcome_checked = false;
  						}
  						echo '<label for="wp_welcome_panel-hide">';
! 						echo '<input type="checkbox" id="wp_welcome_panel-hide"' . checked( (bool) $welcome_checked, true, false ) . ' />';
! 						echo _x( 'Welcome', 'Welcome panel' ) . "</label>\n";
  					}
  				?>
  				<br class="clear" />
  			</div>
  			<?php endif;
! 			if ( $columns ) :
! 				if ( ! empty( $columns['_title'] ) ) : ?>
! 			<h5><?php echo $columns['_title']; ?></h5>
! 			<?php endif; ?>
  			<div class="metabox-prefs">
  				<?php
  				$special = array('_title', 'cb', 'comment', 'media', 'name', 'title', 'username', 'blogname');
***************
*** 858,891 ****
  	 * @since 3.3.0
  	 */
  	function render_screen_layout() {
! 		global $screen_layout_columns;
! 
! 		// Back compat for plugins using the filter instead of add_screen_option()
! 		$columns = apply_filters( 'screen_layout_columns', array(), $this->id, $this );
! 
! 		if ( ! empty( $columns ) && isset( $columns[ $this->id ] ) )
! 			$this->add_option( 'layout_columns', array('max' => $columns[ $this->id ] ) );
! 
! 		if ( ! $this->get_option('layout_columns') ) {
! 			$screen_layout_columns = 0;
  			return;
- 		}
  
! 		$screen_layout_columns = get_user_option("screen_layout_$this->id");
  		$num = $this->get_option( 'layout_columns', 'max' );
  
- 		if ( ! $screen_layout_columns || 'auto' == $screen_layout_columns ) {
- 			if ( $this->get_option( 'layout_columns', 'default' ) )
- 				$screen_layout_columns = $this->get_option( 'layout_columns', 'default' );
- 		}
- 
  		?>
! 		<h5><?php _e('Screen Layout'); ?></h5>
  		<div class='columns-prefs'><?php
  			_e('Number of Columns:');
  			for ( $i = 1; $i <= $num; ++$i ):
  				?>
! 				<label>
  					<input type='radio' name='screen_columns' value='<?php echo esc_attr( $i ); ?>'
  						<?php checked( $screen_layout_columns, $i ); ?> />
  					<?php echo esc_html( $i ); ?>
--- 949,967 ----
  	 * @since 3.3.0
  	 */
  	function render_screen_layout() {
! 		if ( ! $this->get_option('layout_columns') )
  			return;
  
! 		$screen_layout_columns = $this->get_columns();
  		$num = $this->get_option( 'layout_columns', 'max' );
  
  		?>
! 		<h5 class="screen-layout"><?php _e('Screen Layout'); ?></h5>
  		<div class='columns-prefs'><?php
  			_e('Number of Columns:');
  			for ( $i = 1; $i <= $num; ++$i ):
  				?>
! 				<label class="columns-prefs-<?php echo $i; ?>">
  					<input type='radio' name='screen_columns' value='<?php echo esc_attr( $i ); ?>'
  						<?php checked( $screen_layout_columns, $i ); ?> />
  					<?php echo esc_html( $i ); ?>
***************
*** 932,944 ****
  			$per_page = apply_filters( 'edit_posts_per_page', $per_page, $this->post_type );
  
  		?>
! 		<h5><?php _ex('Show on screen', 'Screen Options') ?></h5>
! 		<div class='screen-options'>
! 			<?php if ( !empty($per_page_label) ): ?>
! 				<input type='text' class='screen-per-page' name='wp_screen_options[value]'
! 					id='<?php echo esc_attr( $option ); ?>' maxlength='3'
! 					value='<?php echo esc_attr( $per_page ); ?>' />
! 				<label for='<?php echo esc_attr( $option ); ?>'>
  					<?php echo esc_html( $per_page_label ); ?>
  				</label>
  			<?php endif;
--- 1008,1019 ----
  			$per_page = apply_filters( 'edit_posts_per_page', $per_page, $this->post_type );
  
  		?>
! 		<div class="screen-options">
! 			<?php if ( $per_page_label ) : ?>
! 				<input type="number" step="1" min="1" max="999" class="screen-per-page" name="wp_screen_options[value]"
! 					id="<?php echo esc_attr( $option ); ?>" maxlength="3"
! 					value="<?php echo esc_attr( $per_page ); ?>" />
! 				<label for="<?php echo esc_attr( $option ); ?>">
  					<?php echo esc_html( $per_page_label ); ?>
  				</label>
  			<?php endif;
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/taxonomy.php ./wordpress-3.4/wp-admin/includes/taxonomy.php
*** ./wordpress-3.3.2/wp-admin/includes/taxonomy.php	2010-12-20 03:25:21.000000000 -0600
--- ./wordpress-3.4/wp-admin/includes/taxonomy.php	2012-01-04 16:44:19.000000000 -0600
***************
*** 86,92 ****
   *
   * @param mixed $catarr See defaults below. Set 'cat_ID' to a non-zero value to update an existing category. The 'taxonomy' key was added in 3.0.0.
   * @param bool $wp_error Optional, since 2.5.0. Set this to true if the caller handles WP_Error return values.
!  * @return int|object The ID number of the new or updated Category on success.  Zero or a WP_Error on failure, depending on param $wp_error.
   */
  function wp_insert_category($catarr, $wp_error = false) {
  	$cat_defaults = array('cat_ID' => 0, 'taxonomy' => 'category', 'cat_name' => '', 'category_description' => '', 'category_nicename' => '', 'category_parent' => '');
--- 86,92 ----
   *
   * @param mixed $catarr See defaults below. Set 'cat_ID' to a non-zero value to update an existing category. The 'taxonomy' key was added in 3.0.0.
   * @param bool $wp_error Optional, since 2.5.0. Set this to true if the caller handles WP_Error return values.
!  * @return int|object The ID number of the new or updated Category on success. Zero or a WP_Error on failure, depending on param $wp_error.
   */
  function wp_insert_category($catarr, $wp_error = false) {
  	$cat_defaults = array('cat_ID' => 0, 'taxonomy' => 'category', 'cat_name' => '', 'category_description' => '', 'category_nicename' => '', 'category_parent' => '');
***************
*** 117,123 ****
  	if ( $parent < 0 )
  		$parent = 0;
  
! 	if ( empty($parent) || !category_exists( $parent ) || ($cat_ID && cat_is_ancestor_of($cat_ID, $parent) ) )
  		$parent = 0;
  
  	$args = compact('name', 'slug', 'parent', 'description');
--- 117,123 ----
  	if ( $parent < 0 )
  		$parent = 0;
  
! 	if ( empty( $parent ) || ! term_exists( $parent, $taxonomy ) || ( $cat_ID && term_is_ancestor_of( $cat_ID, $parent, $taxonomy ) ) )
  		$parent = 0;
  
  	$args = compact('name', 'slug', 'parent', 'description');
***************
*** 145,151 ****
   *
   * @since 2.0.0
   *
!  * @param array $catarr The 'cat_ID' value is required.  All other keys are optional.
   * @return int|bool The ID number of the new or updated Category on success. Zero or FALSE on failure.
   */
  function wp_update_category($catarr) {
--- 145,151 ----
   *
   * @since 2.0.0
   *
!  * @param array $catarr The 'cat_ID' value is required. All other keys are optional.
   * @return int|bool The ID number of the new or updated Category on success. Zero or FALSE on failure.
   */
  function wp_update_category($catarr) {
